=== requirements.txt ===
IBMQuantumExperience>=1.9.6
matplotlib>=2.1
networkx>=2.0
numpy>=1.13
ply>=3.10
scipy>=0.19
sympy>=1.0
pillow>=4.2.1
