=== src/qasm-simulator-cpp/Makefile ===
.SUFFIXES:.cc .o .c

all: sim

sim: 
	make -C src

depend: 
	./build_dependencies.sh

clean:
	make -C src clean
