=== requirements.txt ===
jsonschema>=2.6
marshmallow>=3,<4
marshmallow_polyfield>=5.7,<6
networkx>=2.2;python_version>'3.5'
networkx>=2.2,<2.4;python_version=='3.5'
numpy>=1.13
ply>=3.10
psutil>=5
scipy>=1.0
sympy>=1.3
dill>=0.3
