=== debian/changelog ===
qiskit-terra (0.12.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Patch: Support Python 3.9, in test infrastructure. Closes: #972374

 -- Stefano Rivera <stefanor@debian.org>  Sat, 17 Oct 2020 11:53:16 -0700

qiskit-terra (0.12.0-2) unstable; urgency=medium

  * d/patches: backport upstream fix. Closes: #964669

 -- Diego M. Rodriguez <diego@moreda.io>  Sat, 15 Aug 2020 12:26:42 +0200

qiskit-terra (0.12.0-1) unstable; urgency=medium

  * New upstream release. Closes: #933060

 -- Diego M. Rodriguez <diego@moreda.io>  Thu, 11 Jun 2020 18:22:03 +0200

qiskit-terra (0.5.6-1) unstable; urgency=low

  * Initial release. Closes: #880994

 -- Luciano Bello <luciano@debian.org>  Sat, 07 Jul 2018 09:51:09 -0400
