=== debian/control ===
Source: qiskit-terra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Enrique de la Torre <indisoluble_dev@me.com>,
           Luciano Bello <luciano@debian.org>,
           Diego M. Rodriguez <diego@moreda.io>
Section: science
Priority: optional
Build-Depends: cython3 (>= 0.27.1),
               debhelper-compat (= 13),
               dh-python,
               python3-all,
               python3-all-dev,
               python3-setuptools,
# Upstream core dependencies
               python3-dill (>= 0.3),
               python3-jsonschema (>= 2.6),
               python3-marshmallow (>= 3.2),
               python3-marshmallow-polyfield (>= 5.7),
               python3-networkx (>= 2.4),
               python3-numpy (>= 1.13),
               python3-ply (>= 3.10),
               python3-psutil (>= 5),
               python3-scipy (>= 1.0),
               python3-sympy (>= 1.3),
# Upstream optional dependencies
               python3-matplotlib (>= 2.1),
               python3-pil,
               python3-pydot,
               python3-seaborn (>= 0.9.0),
# unavailable upstream optional dependencies
#               python3-ipywidgets (>= 7.3.0),
#               python3-pylatexenc (>= 1.4),
# Test dependencies
               python3-ddt,
               python3-nbconvert,
               python3-nbformat,
               python3-pytest
Vcs-Browser: https://salsa.debian.org/science-team/qiskit-terra
Vcs-Git: https://salsa.debian.org/science-team/qiskit-terra.git
Homepage: https://qiskit.org/
Standards-Version: 4.5.0
Testsuite: autopkgtest-pkg-python
Rules-Requires-Root: no

Package: python3-qiskit-terra
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-matplotlib (>= 2.1),
            python3-pil,
            python3-pydot,
            python3-seaborn (>= 0.9.0)
# unavailable upstream optional dependencies
#            python3-ipywidgets (>= 7.3.0),
#            python3-pylatexenc (>= 1.4),
Description: Quantum Information Science Kit (Qiskit) for Python 3
 Qiskit (Quantum Information Science Kit) is a collection of software developed
 by IBM Research for working with short depth quantum circuits and building
 near term applications and experiments on quantum computers.
 .
 This package contains Terra, which provides the foundations for Qiskit.
 It allows the user to write quantum circuits easily, and takes care of
 the constraints of real hardware (the transpiler).
