=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export PYBUILD_TEST_PYTEST=1
# Add manually qiskit/schemas/examples to the build dir, removing them
# after the tests are run, as they are needed by "test_schemas.py".
export PYBUILD_BEFORE_TEST=cp -r {dir}/qiskit/schemas/examples {build_dir}/qiskit/schemas
export PYBUILD_AFTER_TEST=rm -r {build_dir}/qiskit/schemas/examples
# Skip some tests:
# * TestVisualizationUtils.test_generate_latex_*: require pylatexenc
# * TestLatexSourceGenerator: require pylatexenc
# * TestJupyter.test_jupyter_jobs_pbars: No such kernel named python3
export PYBUILD_TEST_ARGS=test/python -k \
	"not (test_generate_latex or TestLatexSourceGenerator \
	or test_jupyter_jobs_pbars)"

%:
	dh $@ --with python3 --buildsystem=pybuild
