=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/qiskit-terra-$1\.tar\.gz/ \
  https://github.com/Qiskit/qiskit-terra/releases .*/v?(\d\S+)\.tar\.gz
